/* bxCoreSub.h */

#if !defined( BX_CORESUB_H )
#define  BX_CORESUB_H

#include "../bxCore.h"


class CbxCoreSub {
		friend  CbxCore;

	private:		// for CbxCore:
		static bool
		NormalFromAxisForDefault( const CbxCore::AxisForDefaultIn* in, double normal[ 3 ] );
		static bool
		GetDefaultAxisMain( const double normal[ 3 ], CbxCore::AxisForDefaultOut* out );
		static bool
		NormalFromHandleForDefault( const CbxCore::HandleForTransIn* in, double normal[ 3 ] );
		static void
		TanEfromHandleForDefault( const double radialVec[ 3 ], const double normal[ 3 ], double tanE[ 3 ] );
		static bool
		GetDefaultHandleOut( const CbxCore::HandleForTransIn* in, const double radialVec[ 3 ],
			const double tan[ 3 ], CbxCore::HandleForTransOut* out );
		static bool
		NormalInCtlPlaneDeg( const CbxCore::CtlPlaneDegForRotSub sub[ 2 ], const double ctlPlaneDeg, double normalVec[ 3 ] );
		static bool
		ElementInCtlPlaneDeg( const CbxCore::CtlPlaneDegForRotSub sub[ 2 ], const double ctlPlaneDeg,
			double handleVec[ 2 ][ 3 ], double axisInCtlPlaneDeg[ 3 ], double normalInCtlPlaneDeg[ 3 ] );

		static bool
		SetHandleInfo( const double newHandleVec[ 3 ], const CbxCore::HandleForTransPlusIn* in,
			CbxCore::HandleForTransPlusOut* out );
		static bool
		SetCtlInfo( const double newCtlVec[ 3 ], const CbxCore::CtlVecForTransPlusIn* in,
			CbxCore::CtlVecForTransPlusOut* out );

		static bool
		DispChkOnEdgeSurface( const CbxCore::SurfaceForPick* data, bool* dispChk );

	private:
		static void
		NormalFromAxisForDefaultOne( const ulong radialNo0, const ulong radialNo1, const CbxCore::AxisForDefaultIn* in,
			double normal[ 3 ] );
		static bool
		GetCrossBoundOnVertex( const CbxCore::HandleForTransPlusIn* in, const CbxCore::HandleForTransPlusOut* out,
			double axisForNormal[ 3 ] );
		static bool
		GetNewAxisVec( const double newHandleVec[ 3 ], const double axisForNormal[ 3 ], double axisVec[ 2 ][ 3 ] );
		static bool
		ElementInCtlVecPlus( const CbxCore::CtlVecForTransSub sub[ 2 ], double axisInCtlPlaneDeg[ 3 ],
			double defaultNormalInCtlPlaneDeg[ 3 ] );
};


#endif
