/* bxRect.h */

#include "../bxCore.h"


class CbxRect {
	public:
		static bool
		ConvSurface( const CbxCore::SurfaceForPickVertex vertex[ 4 ], CbxCore::RectPatch* rect );

		static void
		PosNormalSurface( const CbxCore::RectPatch* rect, const double uv[ 2 ], double pos[ 3 ], double normalVec[ 3 ] );
		static void
		PosSurface( const CbxCore::RectPatch* rect, const double uv[ 2 ], double pos[ 3 ] );
		static void
		NormalSurface( const CbxCore::RectPatch* rect, const double uv[ 2 ], double normalVec[ 3 ] );

		static bool
		GetDefaultCtlVec( const CbxCore::CtlVecForDefaultInVertex in[ 4 ], CbxCore::CtlVecForDefaultOutVertex out[ 4 ] );

	private:
		static void
		ConvSurfaceMain( const CbxCore::SurfaceForPickVertex vertex[ 4 ], const double f[ 4 ][ 4 ][ 3 ],
			const double a[ 4 ][ 5 ][ 3 ], CbxCore::RectPatch* rect );
		static void
		ConvSurfaceXu0( const CbxCore::SurfaceForPickVertex vertex[ 4 ], const double f[ 4 ][ 5 ][ 3 ],
			const double a[ 4 ][ 5 ][ 3 ], double xu0[ 4 ][ 5 ][ 3 ] );
		static void
		ConvSurfaceXu1( const CbxCore::SurfaceForPickVertex vertex[ 4 ], const double f[ 4 ][ 5 ][ 3 ],
			const double a[ 4 ][ 5 ][ 3 ], double xu1[ 4 ][ 5 ][ 3 ] );
		static void
		ConvSurfaceXv0( const CbxCore::SurfaceForPickVertex vertex[ 4 ], const double f[ 4 ][ 5 ][ 3 ],
			const double a[ 4 ][ 5 ][ 3 ], double xv0[ 5 ][ 4 ][ 3 ] );
		static void
		ConvSurfaceXv1( const CbxCore::SurfaceForPickVertex vertex[ 4 ], const double f[ 4 ][ 5 ][ 3 ],
			const double a[ 4 ][ 5 ][ 3 ], double xv1[ 5 ][ 4 ][ 3 ] );
		static void
		ConvSurfaceXu( const double xu0[ 4 ][ 5 ][ 3 ], const double xu1[ 4 ][ 5 ][ 3 ], double xu[ 5 ][ 5 ][ 3 ] );
		static void
		ConvSurfaceXv( const double xv0[ 5 ][ 4 ][ 3 ], const double xv1[ 5 ][ 4 ][ 3 ], double xv[ 5 ][ 5 ][ 3 ] );
		static void
		ConvSurfaceSub( const double xu[ 5 ][ 5 ][ 3 ], const double xv[ 5 ][ 5 ][ 3 ], CbxCore::RectPatch* rect );

		static void
		PosSurfaceCom( const CbxCore::RectPatch* rect, const double uv[ 2 ], double pos[ 3 ] );
		static void
		PosSurfaceMain( const CbxCore::RectPatch* rect, const double uv[ 2 ], double pos[ 3 ] );
		static void
		NormalSurfaceCom( const CbxCore::RectPatch* rect, const double uv[ 2 ], double normalVec[ 3 ] );
		static void
		DiffUsurface( const CbxCore::RectPatch* rect, const double uv[ 2 ], double vec[ 3 ] );
		static void
		DiffUsurface00( const CbxCore::RectPatch* rect, double vec[ 3 ] );
		static void
		DiffUsurface10( const CbxCore::RectPatch* rect, double vec[ 3 ] );
		static void
		DiffUsurface01( const CbxCore::RectPatch* rect, double vec[ 3 ] );
		static void
		DiffUsurface11( const CbxCore::RectPatch* rect, double vec[ 3 ] );
		static void
		DiffUsurfaceMain( const CbxCore::RectPatch* rect, const double uv[ 2 ], double vec[ 3 ] );
		static void
		DiffVsurface( const CbxCore::RectPatch* rect, const double uv[ 2 ], double vec[ 3 ] );
		static void
		DiffVsurface00( const CbxCore::RectPatch* rect, double vec[ 3 ] );
		static void
		DiffVsurface10( const CbxCore::RectPatch* rect, double vec[ 3 ] );
		static void
		DiffVsurface01( const CbxCore::RectPatch* rect, double vec[ 3 ] );
		static void
		DiffVsurface11( const CbxCore::RectPatch* rect, double vec[ 3 ] );
		static void
		DiffVsurfaceMain( const CbxCore::RectPatch* rect, const double uv[ 2 ], double vec[ 3 ] );

		static void
		SetDisableForSaveTime( void );
		static bool
		ChkEnableForSaveTime( double pu[ 3 ], double pv[ 3 ] );
		static void
		SetEnableForSaveTime( const double pu[ 3 ], const double pv[ 3 ] );

		static bool
		GetPosToPos( const CbxCore::CtlVecForDefaultInVertex vertex[], double posVec[ 4 ][ 2 ][ 3 ] );
		static bool
		GetPosToPosMain( const short no, const CbxCore::CtlVecForDefaultInVertex vertex[], double posVec[ 2 ][ 3 ] );

	private:
		static bool    enableForSaveTime;
		static double  puForSaveTime[ 3 ];
		static double  pvForSaveTime[ 3 ];
};
