/* bxSurface.h */

#include "../bxCore.h"


class CbxSurface {
	public:
		typedef double  Double2x3[ 2 ][ 3 ];
		typedef double  Double3x3[ 3 ][ 3 ];
		typedef double  Double4x3[ 4 ][ 3 ];
		typedef double  Double5x3[ 5 ][ 3 ];
		typedef double  Double6x3[ 6 ][ 3 ];

	public:
		static bool
		GetElement( const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double f[][ 4 ][ 3 ],
			double a[][ 5 ][ 3 ] );

		static void
		OneDimUpPos( const short srcDim, const double src[/*srcDim+1*/][ 3 ], double dst[/*srcDim+2*/][ 3 ] );
		static void
		OneDimUpVecTan( const short srcDim, const double src[/*srcDim*/][ 3 ], double dst[/*srcDim+1*/][ 3 ] );
		static void
		OneDimUpVecCross( const short srcDim, const double src[/*srcDim+1*/][ 3 ], double dst[/*srcDim+2*/][ 3 ] );

		static void
		PosSurface4( const double patch[ 5 ][ 5 ][ 3 ], const double uv[ 2 ], double pos[ 3 ] );
		static void
		DiffUsurface4( const double patch[ 5 ][ 5 ][ 3 ], const double uv[ 2 ], double pos[ 3 ] );
		static void
		DiffVsurface4( const double patch[ 5 ][ 5 ][ 3 ], const double uv[ 2 ], double pos[ 3 ] );
		static void
		PosSurface5( const double patch[ 6 ][ 6 ][ 3 ], const double uv[ 2 ], double pos[ 3 ] );
		static void
		DiffUsurface5( const double patch[ 6 ][ 6 ][ 3 ], const double uv[ 2 ], double vec[ 3 ] );
		static void
		DiffVsurface5( const double patch[ 6 ][ 6 ][ 3 ], const double uv[ 2 ], double vec[ 3 ] );

		static bool
		CtlVecOrgTo3D( const short numVertex, const CbxCore::CtlVecForDefaultInVertex in[],
			const CbxCore::CtlVecForDefaultOutVertex out[], double ctlVec[][ 2 ][ 3 ] );
		static bool
		GetDefaultCtlVec( const short numVertex, const double posVec[][ 2 ][ 3 ], const double srcCtlVec[][ 2 ][ 3 ],
			double dstCtlVec[][ 2 ][ 3 ] );
		static bool
		CtlVec3DtoOrg( const short numVertex, const CbxCore::CtlVecForDefaultInVertex in[], const double ctlVec[][ 2 ][ 3 ],
			CbxCore::CtlVecForDefaultOutVertex out[] );

	private:
		static bool
		GetFormCtlVec( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[],
			double f[ 4 ][ 3 ] );
		static bool
		GetJoinCtlVec( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[],
			double a[ 5 ][ 3 ] );
		static bool
		GetBaseCtlVec( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[],
			double d[ 4 ][ 3 ] );
		static bool
		GetJoinCtlVecMain( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[],
			const double d[ 4 ][ 3 ], double a[ 5 ][ 3 ] );
		static bool
		GetTanVecDim4( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[],
			double e[ 4 ][ 3 ] );
		static bool
		GetBaseJoinCtlVecOnVertex( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[],
			double ad[ 2 ][ 3 ] );
		static void
		GetElementForJoinCtlVec( const double d[ 4 ][ 3 ], const double e[ 4 ][ 3 ], const double ad[ 2 ][ 3 ],
			double dd[ 2 ][ 3 ], double ed[ 2 ][ 3 ], double a0[ 3 ], double a4[ 3 ] );
		static bool
		NormalizeCtlVec( const double ad[ 2 ][ 3 ], const double ed[ 2 ][ 3 ], double ae[ 2 ][ 3 ], double ee[ 2 ][ 3 ] );
		static bool
		GetRatioForJoinCtlVec( const double ee[ 2 ][ 3 ], const double ae[ 2 ][ 3 ], const double dd[ 2 ][ 3 ],
			const double ad[ 2 ][ 3 ], const double ed[ 2 ][ 3 ], double k[ 2 ], double h[ 2 ] );
		static void
		GetJoinCtlVecSub( const double k[ 2 ], const double h[ 2 ], const double d[ 4 ][ 3 ], const double e[ 4 ][ 3 ],
			double a1[ 3 ], double a2[ 3 ], double a3[ 3 ] );
		static bool
		CtlVecOrgTo3Dmain( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex in[],
			const CbxCore::CtlVecForDefaultOutVertex out[], double ctlVec[ 2 ][ 3 ] );
		static bool
		CtlVec3DtoOrgMain( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex in[],
			const double ctlVec[ 2 ][ 3 ], CbxCore::CtlVecForDefaultOutVertex out[] );
};
