/* bxTri.h */

#include "../bxCore.h"


class CbxTri {
	public:
		enum {
			triCalcTypeR,
			triCalcTypeS,
			triCalcTypeT
		};

	public:
		static bool
		ConvSurface( const CbxCore::SurfaceForPickVertex vertex[ 3 ], CbxCore::TriPatch tri[ 3 ] );

		static void
		PosNormalSurface( const CbxCore::TriPatch tri[ 3 ], const double uv[ 2 ], double pos[ 3 ], double normalVec[ 3 ] );
		static void
		PosSurface( const CbxCore::TriPatch tri[ 3 ], const double uv[ 2 ], double pos[ 3 ], short* triCalcType = 0 );
		static void
		NormalSurface( const CbxCore::TriPatch tri[ 3 ], const double uv[ 2 ], double normalVec[ 3 ] );

		static bool
		GetDefaultCtlVec( const CbxCore::CtlVecForDefaultInVertex in[ 3 ], CbxCore::CtlVecForDefaultOutVertex out[ 3 ] );

	private:
		static bool
		ConvSurfaceMain( const CbxCore::SurfaceForPickVertex vertex[ 3 ], CbxCore::TriPatch* tri );
		static void
		ConvSurfaceSub( const CbxCore::SurfaceForPickVertex vertex[ 3 ], const double f[ 3 ][ 4 ][ 3 ],
			const double a[ 3 ][ 5 ][ 3 ], CbxCore::TriPatch* tri );

		static void
		ConvSurfaceTriForm( const CbxCore::SurfaceForPickVertex vertex[ 3 ], const double f[ 3 ][ 4 ][ 3 ],
			CbxCore::Patch5 triForm[ 3 ] );
		static void
		ConvSurfaceTriFormEdge( const CbxCore::SurfaceForPickVertex vertex[ 3 ], double edge[ 3 ][ 4 ][ 3 ] );
		static void
		ConvSurfaceTriFormIn( const CbxCore::SurfaceForPickVertex vertex[ 3 ], const double f[ 3 ][ 4 ][ 3 ],
			double in[ 3 ][ 2 ][ 3 ] );
		static void
		ConvSurfaceTriFormMain( const double edge[ 3 ][ 4 ][ 3 ], const double in[ 3 ][ 2 ][ 3 ],
			CbxCore::Patch5 triForm[ 3 ] );
		static void
		ConvSurfaceTriFormMainEdge( const double edge[ 3 ][ 4 ][ 3 ], CbxCore::Patch5 triForm[ 3 ] );
		static void
		ConvSurfaceTriFormMainInBase( const double in[ 3 ][ 2 ][ 3 ], CbxCore::Patch5 triForm[ 3 ] );

		static void
		ConvSurfaceTriJoin( const CbxCore::SurfaceForPickVertex vertex[ 3 ], const double a[ 3 ][ 5 ][ 3 ],
			CbxCore::Patch6 triJoin[ 3 ] );
		static void
		ConvSurfaceTriJoinEdge( const CbxCore::SurfaceForPickVertex vertex[ 3 ], double edge[ 3 ][ 5 ][ 3 ] );
		static void
		ConvSurfaceTriJoinIn( const CbxCore::SurfaceForPickVertex vertex[ 3 ], const double a[ 3 ][ 5 ][ 3 ],
			double in[ 3 ][ 3 ][ 3 ] );
		static void
		ConvSurfaceTriJoinMain( const double edge[ 3 ][ 5 ][ 3 ], const double in[ 3 ][ 3 ][ 3 ],
			CbxCore::Patch6 triJoin[ 3 ] );
		static void
		ConvSurfaceTriJoinMainEdge( const double edge[ 3 ][ 5 ][ 3 ], CbxCore::Patch6 triJoin[ 3 ] );
		static void
		ConvSurfaceTriJoinMainInBase( const double in[ 3 ][ 3 ][ 3 ], CbxCore::Patch6 triJoin[ 3 ] );
		static void
		ConvSurfaceTriJoinMainInCenterU0( CbxCore::PatchPnt triJoin[ 6 ][ 6 ] );
		static void
		ConvSurfaceTriJoinMainInCenterV0( CbxCore::PatchPnt triJoin[ 6 ][ 6 ] );
		static void
		ConvSurfaceTriJoinMainInCenterU1( CbxCore::PatchPnt triJoin[ 6 ][ 6 ] );

		static void
		ConvFormTriToRect( const CbxCore::Patch5 triForm[ 3 ], CbxCore::Patch5 rectForm[ 3 ] );
		static void
		ConvJoinTriToRect( const CbxCore::Patch6 triJoin[ 3 ], CbxCore::Patch6 rectJoin[ 3 ] );
		static void
		DimUpAndCopy( const short numDim, const short srcDim, const CbxCore::PatchPnt** src, CbxCore::PatchPnt** dst );

		static void
		PosSurfaceCom( const CbxCore::TriPatch tri[ 3 ], const double uv[ 2 ], double pos[ 3 ], short* triCalcType = 0 );
		static short
		GetTriCalcType( const double uv[ 2 ] );
		static void
		PosSurfaceMain( const CbxCore::TriPatch* tri, const double uv[ 2 ], double pos[ 3 ] );
		static void
		ConvUV( const short triCalcType, const double srcUV[ 2 ], double dstUV[ 2 ] );
		static void
		PosSurfaceSub( const short triCalcType, const CbxCore::PatchPnt form[ 5 ][ 5 ],
			const CbxCore::PatchPnt join[ 6 ][ 6 ], const double param[ 2 ], const double uv[ 2 ], double pos[ 3 ] );
		static void
		NormalSurfaceCom( const CbxCore::TriPatch tri[ 3 ], const double uv[ 2 ], double normalVec[ 3 ] );
		static void
		DiffUsurface( const CbxCore::TriPatch tri[ 3 ], const double uv[ 2 ], double vec[ 3 ], short* triCalcType = 0 );
		static void
		DiffUsurfaceVertex( const CbxCore::TriPatch* tri, double vec[ 3 ] );
		static void
		DiffUsurfaceMain( const CbxCore::TriPatch* tri, const double uv[ 2 ], double vec[ 3 ] );
		static void
		DiffUsurfaceSub( const short triCalcType, const CbxCore::PatchPnt form[ 5 ][ 5 ],
			const CbxCore::PatchPnt join[ 6 ][ 6 ], const double param[ 3 ], const double uv[ 2 ], double vec[ 3 ] );
		static void
		DiffVsurface( const CbxCore::TriPatch tri[ 3 ], const double uv[ 2 ], double vec[ 3 ], short* triCalcType = 0 );
		static void
		DiffVsurfaceVertex( const CbxCore::TriPatch* tri, double vec[ 3 ] );
		static void
		DiffVsurfaceMain( const CbxCore::TriPatch* tri, const double uv[ 2 ], double vec[ 3 ] );
		static void
		DiffVsurfaceSub( const short triCalcType, const CbxCore::PatchPnt form[ 5 ][ 5 ],
			const CbxCore::PatchPnt join[ 6 ][ 6 ], const double param[ 3 ], const double uv[ 2 ], double vec[ 3 ] );

		static void
		SetDisableForSaveTime( void );
		static bool
		ChkEnableForSaveTime( const short triCalcType, double p0[ 3 ], double p1[ 3 ] );
		static void
		SetEnableForSaveTime( const short triCalcType, const double p0[ 3 ], const double p1[ 3 ] );

		static bool
		GetPosToPos( const CbxCore::CtlVecForDefaultInVertex vertex[], double posVec[ 3 ][ 2 ][ 3 ] );
		static bool
		GetPosToPosMain( const short no, const CbxCore::CtlVecForDefaultInVertex vertex[], double posVec[ 2 ][ 3 ] );
		static bool
		CorrectDefaultCtlVec( const CbxCore::CtlVecForDefaultInVertex vertex[], double ctlVec[ 3 ][ 2 ][ 3 ] );
		static bool
		CorrectDefaultCtlVecMain( const short no, const CbxCore::CtlVecForDefaultInVertex vertex[], double ctlVec[ 2 ][ 3 ] );

	private:
		static bool    enableForSaveTime[ 3 ];
		static double  p0ForSaveTime[ 3 ][ 3 ];
		static double  p1ForSaveTime[ 3 ][ 3 ];

		static const double  ratioForCorrectDefaultCtlVec;
};
