/* bxProc.h */

#include "../bxType.h"
#include "../Core/bxCore.h"
#include "../DataBase/bxDB.h"



class CbxProc : public CbxCore, CbxDB {
	public:
		static bool
		DefaultAxis( const ulong vertexNo );
		static bool
		DefaultHandle( const ulong edgeNo, const short beginEndNo );
		static bool
		DefaultCtlVec( const ulong edgeNo, const short beginEndNo, bool* dispChk );

		static bool
		SetVertexPos( const ulong vertexNo, const double newPos[ 3 ] );
		static bool
		RotVertex( const ulong vertexNo, const double origin[ 3 ], const double axis[ 3 ], const double deg );
		static bool
		ScaleVertex( const ulong vertexNo, const double origin[ 3 ], const double scale );
		static bool
		SetHandleVec( const ulong edgeNo, const short beginEndNo, const double newHandleVec[ 2 ] );
		static bool
		SetHandleInfo( const ulong edgeNo, const short beginEndNo, const double newHandleVec[ 3 ] );
		static bool
		SetCtlPlaneDeg( const ulong edgeNo, const short beginEndNo, const double newCtlPlaneDeg );
		static bool
		SetCtlVec( const ulong edgeNo, const short beginEndNo, const double newCtlVec[ 2 ][ 2 ] );
		static bool
		SetCtlInfo( const ulong edgeNo, const short beginEndNo, const short minusPlusNo, const double newCtlVec[ 3 ] );

		static void
		GetVertexPos( const ulong vertexNo, double vertexPos[ 3 ] );
		static void
		GetNormalOnVertex( const ulong vertexNo, double normalVec[ 3 ] );
		static bool
		GetHandle( const ulong edgeNo, const short beginEndNo, bool* dispChk, double handleVec[ 3 ] );
		static bool
		GetAxisInCtlPlaneDeg( const ulong edgeNo, const short beginEndNo, bool* dispChk, double axisVec[ 3 ] );
		static bool
		GetNormalInCtlPlaneDeg( const ulong edgeNo, const short beginEndNo, bool* dispChk, double normalVec[ 3 ] );
		static bool
		GetAxisInCtlVec( const ulong edgeNo, const short beginEndNo, const short minusPlusNo,
			bool* dispChk, double axis[ 2 ][ 3 ] );
		static bool
		GetCtlInCtlVec( const ulong edgeNo, const short beginEndNo, const short minusPlusNo,
			bool* dispChk, double ctlVec[ 3 ] );

		static bool
		ConvEdge( const ulong edgeNo, bool* dispChk, double bezierLine[ 4 ][ 3 ] );

		static bool
		LoadSurfaceForPick( const ulong edgeNo, const short beginEndNo, CbxCore::SurfaceForPick* surface, bool* dispChk );

		static bool
		ErrChk( void );

	private:
		static bool
		AllocDefaultAxis( const ushort numRadial, CbxCore::AxisForDefaultSub** buf );
		static void
		FreeDefaultAxis( CbxCore::AxisForDefaultSub* buf );

		static bool
		ErrChkAxisVec( const ulong vertexNo );
		static bool
		ErrChkHandleVec1( const ulong edgeNo, const short beginEndNo );
		static bool
		ErrChkCtlPlaneDeg( const ulong edgeNo, const short beginEndNo );
		static bool
		ErrChkCtlVec( const ulong edgeNo, const short beginEndNo );
};
