/* bxUtil.cpp */

#include "bxUtil.h"
#include "../Math/bxMath.h"



double*  CbxUtil::
PosBezierLine( const double bezierLine[ 4 ][ 3 ], const double t, double pos[ 3 ] )
{
	short  i;
	double  t2, t3, mt, mt2, mt3;

	t2 = t * t;			t3  = t2 * t;
	mt = 1.0 - t;		mt2 = mt * mt;		mt3 = mt2 * mt;

	for( i=0; i<3; i++ ) {
		pos[ i ] = mt3         * bezierLine[ 0 ][ i ]
				 + 3 * t * mt2 * bezierLine[ 1 ][ i ]
				 + 3 * t2 * mt * bezierLine[ 2 ][ i ]
				 + t3          * bezierLine[ 3 ][ i ];
	}

	return( pos );
}
