/* bvEdge.cpp */

#include "../BeziexView.h"


ulong              CbvEdge::numLineAry		= 0;
CbvEdge::LineRec*  CbvEdge::lineAry			= 0;



bool  CbvEdge::
Update( void )
{
	bool  result;

	FreeData();

	result = Alloc();
	if( result == true ) {
		CbvMessage::Error( IDS_CANNOTCONTINUE );
		return( true );
	}

	SetEdge();

	return( false );
}


bool  CbvEdge::
Alloc( void )
{
	bool  result;

	result = Proc( FuncDispChk );
	if( result == true )
		return( true );

	if( AllocData() == true )
		return( true );

	return( false );
}


bool  CbvEdge::
Proc( bool ( *Exec )( const ulong edgeNo, const ulong lineNo, bool* dispChk ) )
{
	ulong  i;
	bool   result;

	numLineAry = 0;

	for( i=0; i<CbxDB::NumEdgeAry(); i++ ) {
		result = ProcMain( i, Exec );
		if( result == true )
			return( true );
	}

	return( false );
}


bool  CbvEdge::
ProcMain( const ulong edgeNo, bool ( *Exec )( const ulong edgeNo, const ulong lineNo, bool* dispChk ) )
{
	bool  result, dispChk;

	result = ( *Exec )( edgeNo, numLineAry, &dispChk );
	if( result == true )
		return( true );

	if( dispChk == true )
		numLineAry += numLineOnEdge;

	return( false );
}


bool  CbvEdge::
FuncDispChk( const ulong edgeNo, const ulong lineNo, bool* dispChk )
{
	bool    result;
	double  bezierLine[ 4 ][ 3 ];

	result = CbxProc::ConvEdge( edgeNo, dispChk, bezierLine );
	if( result == true )
		return( true );

	return( false );
}


bool  CbvEdge::
AllocData( void )
{
	lineAry = new LineRec[ numLineAry ];
	if( lineAry == 0 )
		return( true );

	return( false );
}


void  CbvEdge::
FreeData( void )
{
	if( numLineAry == 0 )
		return;

	delete [] lineAry;

	numLineAry = 0;
	lineAry    = 0;
}


void  CbvEdge::
SetEdge( void )
{
	bool  result;

	result = Proc( FuncSetEdge );
	if( result == true ) {
		CbvMessage::Error( IDS_CANNOTCONTINUE );
		return;
	}
}


bool  CbvEdge::
FuncSetEdge( const ulong edgeNo, const ulong lineNo, bool* dispChk )
{
	bool    result;
	double  bezierLine[ 4 ][ 3 ];

	result = CbxProc::ConvEdge( edgeNo, dispChk, bezierLine );
	if( result == true )
		return( true );

	if( *dispChk == true )
		SetLine( lineNo, bezierLine );

	return( false );
}


void  CbvEdge::
SetLine( const ulong lineNo, const double bezierLine[ 4 ][ 3 ] )
{
	short   i, j;
	double  t;

	for( i=0; i<numLineOnEdge; i++ ) {
		for( j=0; j<2; j++ ) {
			t = ( double )( i + j ) / numLineOnEdge;
			CbxUtil::PosBezierLine( bezierLine, t, lineAry[ lineNo+i ].vertex[ j ] );
		}
	}
}
