/* bvAfterRead.h */

#include <windows.h>
#include "../bvType.h"


class CbvAfterRead : public CbvRead {
	private:
		struct RadialForSort {
			ulong  edgeNo;
			ulong  indexNo;
		};

	public:
		static bool
		Proc( void );

	private:
		static bool
		ConvReadData( void );
		static bool
		AllocSortRadial( RadialForSort** radial );
		static void
		SetSortRadial( RadialForSort* radial );
		static int
		SortFunc( const void* idt0, const void* idt1 );
		static bool
		AfterMain( const RadialForSort* radial );
		static void
		FreeSortRadial( RadialForSort* radial );
		static bool
		ReadDataToBeziexDB( void );
		static bool
		AllocBeziexDB( void );
		static void
		ReadToDBvertex( void );
		static void
		ReadToDBedge( void );
		static bool
		GetDefaultAxis( void );
		static bool
		GetDefaultHandle( void );
		static bool
		GetDefaultCtlVec( void );
		static bool
		GetDefaultCtlVecMain( bool* surfaceErr );
		static bool
		GetDefaultCtlVecVertex( const ulong edgeNo, const short beginEndNo, bool* execOp, short* chkSurfExist );
		static bool
		ErrChkVertexPos( void );
};
