/* bvRead.h */

#include <windows.h>
#include "../bvType.h"


class CbvRead {
	public:
		struct VertexRec {
			double  vertexPos[ 3 ];
			ushort  numRadial;
			bool    loopFlag;
			ulong   startIndex;
		};

		struct RadialRec {
			ulong   edgeNo;
			ushort  beginEndNo;
		};

	public:
		static bool
		Proc( HWND hWnd, bool* cancel );
		static void
		FreeData( void );

	private:
		static bool
		ReadProc( HWND hWnd, bool* cancel );
		static bool
		OpenFile( HWND hWnd, bool* cancel );
		static bool
		GetFileName( HWND hWnd, char fileName[ MAX_PATH ], bool* cancel );
		static bool
		OpenFileMain( const char fileName[ MAX_PATH ] );
		static bool
		ReadMain( void );
		static bool
		ReadHeader( void );
		static bool
		ReadData( const bool setting );
		static bool
		ReadVertexHeader( VertexRec* vertex );
		static bool
		ReadVertexRadial( const bool setting, const ulong startIndex, ulong* numAry );
		static void
		SetRadialAry( const bool setting, const ulong no, const ulong edgeNo );
		static void
		SetVertexAry( const bool setting, const ulong no, const VertexRec* vertex );
		static bool
		AllocVertex( void );
		static bool
		AllocRadial( void );
		static void
		FreeVertex( void );
		static void
		FreeRadial( void );

	protected:
		static ulong         numVertexAry;
		static ulong         numRadialAry;
		static VertexRec*    vertexAry;
		static RadialRec*    radialAry;

	private:
		static const char    fileExt[ 16 ];
		static const double  fileVersion;
		static const char    loopStr[ 2 ][ 16 ];
};
