/* bvReadCore.h */

#include <stdio.h>
#include "../bvType.h"


class CbvReadCore {
	private:
		enum {
			lenStrBuf	= 256
		};

	public:
		static FILE*
		GetFP( void );
		static void
		SetFP( FILE* const fp );
		static const char*
		BeginStr( void );
		static const char*
		EndStr( void );

		static bool
		ReadStr( char str[ lenStrBuf ] );
		static bool
		ReadFloat( double* value );
		static bool
		ReadUInt( ulong* value );
		static bool
		ReadBool( const char* falseStr, const char* trueStr, bool* boolean );
		static bool
		ReadFloat3( double value[ 3 ] );
		static bool
		ReadUIntAry( const bool setting, const ulong startIndex,
			void ( *SetAry )( const bool setting, const ulong no, const ulong data ), ulong* numAry );
		static bool
		ReadFloatStr( bool* chkStr, void** data );
		static bool
		ReadUIntStr( bool* chkStr, void** data );
		static bool
		ReadCmpStr1( const char cmpStr[ lenStrBuf ], bool* equ );
		static bool
		ReadCmpStrN( const short numStr, const char** cmpStr, bool* equ, short* no );
		static bool
		ReadUIntCmpStr( const char cmpStr[], bool* chkStr, void** data );
		static char*
		CopyStr( const void* data, char* str );
		static double
		GetFloat( const void* data );
		static ulong
		GetUInt( const void* data );
		static bool
		GetBool( const void* data );

	private:
		static bool
		ReadSelect( char str[ lenStrBuf ], bool* punct );
		static void
		ReadComment( void );
		static bool
		ReadPunct( char* chr );
		static bool
		ReadNonPunct( char str[ lenStrBuf ], bool* overflow );
		static void
		ChkName( const char str[ lenStrBuf ], bool* chk );
		static bool
		ConvFloat( const char str[ lenStrBuf ], bool* chk, double* value );
		static bool
		ConvUInt( const char str[ lenStrBuf ], bool* chk, ulong* value );

	private:
		static FILE*       fileStream;
		static const char  beginStr[ 16 ];
		static const char  endStr[ 16 ];
		static const char  nonPunctStr[ 32 ];
		static const char  commentChr[ 2 ];
};
