/* bvDlog.cpp */

#include <stdio.h>
#include "../BeziexView.h"


double CbvDlogRotSurfX::data	= 0.0;
double CbvDlogRotSurfY::data	= 0.0;
double CbvDlogRotSurfZ::data	= 0.0;
ulong  CbvDlogSelVer::data		= 0;
ulong  CbvDlogSelHand::data		= 0;
ulong  CbvDlogSelCtlBar::data	= 0;
double CbvDlogVertex::data[ 3 ] = { 0.0, 0.0, 0.0 };
double CbvDlogHandle::data[ 3 ] = { 0.0, 0.0, 0.0 };
double CbvDlogCtlBar::data[ 3 ] = { 0.0, 0.0, 0.0 };



int  CbvDlog::
ProcFloat( HWND hWnd, const WORD titleID, double* data )
{
	int   result;
	char  title[ 256 ], str[ 256 ];

	LoadString( CbvMain::HInst(), titleID, title, 256-1 );
	sprintf( str, "%lf", *data );

	result = ProcMain( hWnd, title, str );

	if( result == IDOK )
		sscanf( str, "%lg", data );

	return( result );
}


int  CbvDlog::
ProcUInt( HWND hWnd, const char title[ 256 ], ulong* data )
{
	int   result;
	char  str[ 256 ];

	sprintf( str, "%lu", *data );

	result = ProcMain( hWnd, title, str );

	if( result == IDOK )
		sscanf( str, "%lu", data );

	return( result );
}


int  CbvDlog::
ProcMain( HWND hWnd, const char title[ 256 ], char* data )
{
	Param  param;
	int    result;

	strcpy( param.title, title );
	strcpy( param.data,  data );

	result = DialogBoxParam( CbvMain::HInst(), MAKEINTRESOURCE( IDD_INPUT ), hWnd,
				( DLGPROC )DlgProc, ( LPARAM )( &param ) );
	if( result == IDOK )
		strcpy( data, param.data );

	return( result );
}


LRESULT CALLBACK  CbvDlog::
DlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static Param*  param = 0;

	switch( uMsg ) {
		case WM_INITDIALOG:
			param = ( Param* )lParam;
			SetDlgItemText( hDlg, IDC_TITLE, param->title );
			SetDlgItemText( hDlg, IDC_DATA,  param->data  );

			SetFocus( GetDlgItem( hDlg, IDC_DATA ) );
			SendDlgItemMessage( hDlg, IDC_DATA, EM_SETSEL, 0, -1 );
			return( FALSE );

		case WM_COMMAND:
			switch( LOWORD( wParam ) ) {
				case IDOK:
					GetDlgItemText( hDlg, IDC_DATA, param->data, 256-1 );
					EndDialog( hDlg, IDOK );
					break;
				case IDCANCEL:
					EndDialog( hDlg, IDCANCEL );
					break;
			}
			break;

		default:
			return( FALSE );
	}

	return( TRUE );
}


int  CbvDlog::
ProcFloat3( HWND hWnd, const WORD titleID, double data[ 3 ] )
{
	int    result;
	char   title[ 256 ], buf[ 3 ][ 256 ], *str[ 3 ];
	short  i;

	for( i=0; i<3; i++ )
		str[ i ] = buf[ i ];

	LoadString( CbvMain::HInst(), titleID, title, 256-1 );
	for( i=0; i<3; i++ )
		sprintf( str[ i ], "%lf", data[ i ] );

	result = ProcMain3( hWnd, title, str );

	if( result == IDOK ) {
		for( i=0; i<3; i++ )
			sscanf( str[ i ], "%lg", &data[ i ] );
	}

	return( result );
}


int  CbvDlog::
ProcMain3( HWND hWnd, const char title[ 256 ], char* data[ 3 ] )
{
	Param3  param;
	int     result;
	short   i;

	strcpy( param.title, title );
	for( i=0; i<3; i++ )
		strcpy( param.data[ i ],  data[ i ] );

	result = DialogBoxParam( CbvMain::HInst(), MAKEINTRESOURCE( IDD_XYZ ), hWnd,
				( DLGPROC )DlgProc3, ( LPARAM )( &param ) );
	if( result == IDOK ) {
		for( i=0; i<3; i++ )
			strcpy( data[ i ], param.data[ i ] );
	}

	return( result );
}


LRESULT CALLBACK  CbvDlog::
DlgProc3( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static Param3*  param = 0;

	switch( uMsg ) {
		case WM_INITDIALOG:
			param = ( Param3* )lParam;
			SetDlgItemText( hDlg, IDC_TITLE, param->title     );
			SetDlgItemText( hDlg, IDC_X,     param->data[ 0 ] );
			SetDlgItemText( hDlg, IDC_Y,     param->data[ 1 ] );
			SetDlgItemText( hDlg, IDC_Z,     param->data[ 2 ] );

			SetFocus( GetDlgItem( hDlg, IDC_X ) );
			SendDlgItemMessage( hDlg, IDC_X, EM_SETSEL, 0, -1 );
			return( FALSE );

		case WM_COMMAND:
			switch( LOWORD( wParam ) ) {
				case IDOK:
					GetDlgItemText( hDlg, IDC_X, param->data[ 0 ], 256-1 );
					GetDlgItemText( hDlg, IDC_Y, param->data[ 1 ], 256-1 );
					GetDlgItemText( hDlg, IDC_Z, param->data[ 2 ], 256-1 );
					EndDialog( hDlg, IDOK );
					break;
				case IDCANCEL:
					EndDialog( hDlg, IDCANCEL );
					break;
			}
			break;

		default:
			return( FALSE );
	}

	return( TRUE );
}


int  CbvDlogRotSurfX::
Proc( HWND hWnd )
{
	int  result;

	data = 0.0;
	result = ProcFloat( hWnd, IDS_ROTSURFX, &data );
	if( result == IDOK )
		CbvGL::RotSurfX( data );

	return( result );
}

int  CbvDlogRotSurfY::
Proc( HWND hWnd )
{
	int  result;

	data = 0.0;
	result = ProcFloat( hWnd, IDS_ROTSURFY, &data );
	if( result == IDOK )
		CbvGL::RotSurfY( data );

	return( result );
}

int  CbvDlogRotSurfZ::
Proc( HWND hWnd )
{
	int  result;

	data = 0.0;
	result = ProcFloat( hWnd, IDS_ROTSURFZ, &data );
	if( result == IDOK )
		CbvGL::RotSurfZ( data );

	return( result );
}

int  CbvDlogSelVer::
Proc( HWND hWnd )
{
	char  format[ 256 ], title[ 256 ];
	int   result;

	LoadString( CbvMain::HInst(), IDS_SELVER, format, 256-1 );
	sprintf( title, format, CbxDB::NumVertexAry() - 1 );

	result = ProcUInt( hWnd, title, &data );
	if( result == IDOK ) {
		if( data > ( CbxDB::NumVertexAry() - 1 ) )
			data = CbxDB::NumVertexAry() - 1;
		CbvDlogSelHand::ResetData();
		CbvDlogSelCtlBar::ResetData();
	}

	return( result );
}

int  CbvDlogSelHand::
Proc( HWND hWnd )
{
	char  format[ 256 ], title[ 256 ];
	int   result;
	CbxDB::VertexRec  vertex;

	CbxDB::LoadVertexRec( CbvDlogSelVer::Data(), &vertex );

	LoadString( CbvMain::HInst(), IDS_SELHAND, format, 256-1 );
	sprintf( title, format, vertex.numRadial - 1 );

	result = ProcUInt( hWnd, title, &data );
	if( result == IDOK ) {
		if( data > ( ulong )( vertex.numRadial - 1 ) )
			data = vertex.numRadial - 1;
		CbvDlogSelCtlBar::ResetData();
	}

	return( result );
}

int  CbvDlogSelCtlBar::
Proc( HWND hWnd )
{
	char  title[ 256 ];
	int   result;

	LoadString( CbvMain::HInst(), IDS_SELCTLBAR, title, 256-1 );

	result = ProcUInt( hWnd, title, &data );
	if( result == IDOK ) {
		if( data > 1 )
			data = 1;
	}

	return( result );
}

int  CbvDlogVertex::
Proc( HWND hWnd )
{
	int   result;
	bool  errResult;

	CbxProc::GetVertexPos( CbvDlogSelVer::Data(), data );

	result = ProcFloat3( hWnd, IDS_VERTEX, data );
	if( result == IDOK ) {
		errResult = CbvGL::ErrChkVertexPos( data );
		if( errResult == true )
			return( IDCANCEL );
		errResult = CbxProc::SetVertexPos( CbvDlogSelVer::Data(), data );
		if( errResult == true ) {
			CbvMessage::Error( IDS_CANNOTCONTINUE );
			return( IDCANCEL );
		}
		CbvEdge::Update();
		CbvPolygon::Update();
	}

	return( result );
}

int  CbvDlogHandle::
Proc( HWND hWnd )
{
	int    result;
	bool   errResult, dispChk;
	ulong  edgeNo;
	short  beginEndNo;

	errResult = CbxDB::VertexRadialToEdge( CbvDlogSelVer::Data(), CbvDlogSelHand::Data(), &edgeNo, &beginEndNo );
	if( errResult == true ) {
		CbvMessage::Error( IDS_CANNOTCONTINUE );
		return( IDCANCEL );
	}
	errResult = CbxProc::GetHandle( edgeNo, beginEndNo, &dispChk, data );
	if( errResult == true ) {
		CbvMessage::Error( IDS_CANNOTCONTINUE );
		return( IDCANCEL );
	}
	else if( dispChk == false ) {
		CbvMessage::MessageOK( IDS_CANNOTSETHANDLE );
		return( IDCANCEL );
	}

	result = ProcFloat3( hWnd, IDS_HANDLE, data );
	if( result == IDOK ) {
		errResult = CbxProc::SetHandleInfo( edgeNo, beginEndNo, data );
		if( errResult == true ) {
			CbvMessage::Error( IDS_CANNOTCONTINUE );
			return( IDCANCEL );
		}
		CbvEdge::Update();
		CbvPolygon::Update();
	}

	return( result );
}

int  CbvDlogCtlBar::
Proc( HWND hWnd )
{
	int    result;
	bool   errResult, dispChk;
	ulong  edgeNo;
	short  beginEndNo;

	errResult = CbxDB::VertexRadialToEdge( CbvDlogSelVer::Data(), CbvDlogSelHand::Data(), &edgeNo, &beginEndNo );
	if( errResult == true ) {
		CbvMessage::Error( IDS_CANNOTCONTINUE );
		return( IDCANCEL );
	}
	errResult = CbxProc::GetCtlInCtlVec( edgeNo, beginEndNo, CbvDlogSelCtlBar::Data(), &dispChk, data );
	if( errResult == true ) {
		CbvMessage::Error( IDS_CANNOTCONTINUE );
		return( IDCANCEL );
	}
	else if( dispChk == false ) {
		CbvMessage::MessageOK( IDS_CANNOTSETCTLBAR );
		return( IDCANCEL );
	}

	result = ProcFloat3( hWnd, IDS_CTLBAR, data );
	if( result == IDOK ) {
		errResult = CbxProc::SetCtlInfo( edgeNo, beginEndNo, CbvDlogSelCtlBar::Data(), data );
		if( errResult == true ) {
			CbvMessage::Error( IDS_CANNOTCONTINUE );
			return( IDCANCEL );
		}
		CbvEdge::Update();
		CbvPolygon::Update();
	}

	return( result );
}


void  CbvMessage::
MessageOK( const UINT messageID )
{
	char  message[ 256 ], title[ 32 ];
	HWND  hWnd;

	hWnd = GetActiveWindow();
	LoadString( CbvMain::HInst(), messageID, message, 256-1 );
	LoadString( CbvMain::HInst(), IDS_MESSAGETITLE, title, 32-1 );
	MessageBox( hWnd, message, title, MB_OK );
}


void  CbvMessage::
Error( const UINT messageID )
{
	char  message[ 256 ], title[ 32 ];
	HWND  hWnd;

	hWnd = GetActiveWindow();
	LoadString( CbvMain::HInst(), messageID, message, 256-1 );
	LoadString( CbvMain::HInst(), IDS_ERRORTITLE, title, 32-1 );
	MessageBox( hWnd, message, title, MB_OK );

	CbvMain::FinishProc();
}
