/* bvDlog.h */

#include <windows.h>



class CbvDlog {
	private:
		struct Param {
			char  title[ 256 ];
			char  data[ 256 ];
		};

		struct Param3 {
			char  title[ 256 ];
			char  data[ 3 ][ 256 ];
		};

	protected:
		static int
		ProcFloat( HWND hWnd, const WORD titleID, double* data );
		static int
		ProcUInt( HWND hWnd, const char title[ 256 ], ulong* data );
		static int
		ProcFloat3( HWND hWnd, const WORD titleID, double data[ 3 ] );

	private:
		static int
		ProcMain( HWND hWnd, const char title[ 256 ], char* data );
		static LRESULT CALLBACK
		DlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );
		static int
		ProcMain3( HWND hWnd, const char title[ 256 ], char* data[ 3 ] );
		static LRESULT CALLBACK
		DlgProc3( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );
};


class CbvDlogRotSurfX : public CbvDlog {
	public:
		static int
		Proc( HWND hWnd );
		static double
		Data( void )		{  return( data );  }

	private:
		static double  data;
};

class CbvDlogRotSurfY : public CbvDlog {
	public:
		static int
		Proc( HWND hWnd );
		static double
		Data( void )		{  return( data );  }

	private:
		static double  data;
};

class CbvDlogRotSurfZ : public CbvDlog {
	public:
		static int
		Proc( HWND hWnd );
		static double
		Data( void )		{  return( data );  }

	private:
		static double  data;
};

class CbvDlogSelVer : public CbvDlog {
	public:
		static int
		Proc( HWND hWnd );
		static ulong
		Data( void )		{  return( data );  }

	private:
		static ulong  data;
};

class CbvDlogSelHand : public CbvDlog {
	public:
		static int
		Proc( HWND hWnd );
		static ushort
		Data( void )		{  return( ( ushort )data );  }

		static void
		ResetData( void )	{  data = 0;  }

	private:
		static ulong  data;
};

class CbvDlogSelCtlBar : public CbvDlog {
	public:
		static int
		Proc( HWND hWnd );
		static ushort
		Data( void )		{  return( ( short )data );  }

		static void
		ResetData( void )	{  data = 0;  }

	private:
		static ulong  data;
};

class CbvDlogVertex : public CbvDlog {
	public:
		static int
		Proc( HWND hWnd );
		static double
		Data( const short index )		{  return( data[ index ] );  }

	private:
		static double  data[ 3 ];
};

class CbvDlogHandle : public CbvDlog {
	public:
		static int
		Proc( HWND hWnd );
		static double
		Data( const short index )		{  return( data[ index ] );  }

	private:
		static double  data[ 3 ];
};

class CbvDlogCtlBar : public CbvDlog {
	public:
		static int
		Proc( HWND hWnd );
		static double
		Data( const short index )		{  return( data[ index ] );  }

	private:
		static double  data[ 3 ];
};



class CbvMessage {
	public:
		static void
		MessageOK( const UINT messageID );
		static void
		Error( const UINT messageID );
};
