/* bvGL.h */

#include <windows.h>
#include <gl\gl.h>


class CbvGL {
	public:
		static bool
		Init( HWND hWnd );
		static void
		Finish( void );
		static void
		Paint( HWND hWnd, HDC hDC );

		static void
		SetDirStd( void );
		static void
		SetDirTop( void );
		static void
		SetDirFront( void );
		static void
		SetDirSide( void );
		static void
		RotSurfX( const double deg );
		static void
		RotSurfY( const double deg );
		static void
		RotSurfZ( const double deg );

		static void
		GetCurrentMat( double mat[ 4 ][ 4 ] );

		static bool
		ErrChkVertexPos( const double vertexPos[ 3 ] );

	private:
		static void
		DrawWire( HWND hWnd );
		static void
		DrawSurf( HWND hWnd );
		static void
		SetView( HWND hWnd, const RECT* rect );
		static void
		SetPerspective( HWND hWnd );
		static void
		SetObj( void );
		static void
		SetMaterial( void );
		static void
		SetLight( void );
		static void
		SetMatrix( void );
		static void
		DrawEdge( void );
		static void
		DrawPolygon( void );

	public:
		static const double  minPosInSpace[ 3 ];
		static const double  maxPosInSpace[ 3 ];

	private:
		static HGLRC   hRC;
		static double  currentMat[ 4 ][ 4 ];
};
