/* bvGLelement.h */

#include <windows.h>
#include <gl\gl.h>


class CbvGLelement {
	private:
		struct PosInfoSub {
			double  vertexPos[ 3 ];
			bool    dispChkForHandle;
			double  handlePos[ 3 ];
			bool    dispChkForCtl;
			double  ctlPos[ 3 ];
			bool    dispChkForWing;
			double  wingPos[ 3 ];
			bool    extFlag;
			double  wingPos2[ 3 ];
			double  wingPos3[ 3 ];
		};

		struct PosInfo {
			PosInfoSub  dt[ 2 ];
		};

		struct WingHandleInfo {
			double  handlePosOrg[ 3 ];
			bool    extFlag;
			double  handlePosRadial[ 3 ];
			double  vertexPosRadial[ 3 ];
		};

		struct WingHandleInfoSub {
			double  handleVecOrg[ 3 ];
			bool    extFlag;
			double  vertexPosRadial[ 3 ];
			double  handleVecRadial[ 3 ];
		};

	public:
		static void
		Draw( void );

	private:
		static void
		SetMaterial( void );
		static void
		DrawElement( void );
		static bool
		DrawLadder( void );
		static bool
		GetElementPos( PosInfo* pos );
		static void
		DrawElementRect( const PosInfo* pos );
		static void
		DrawElementLine( const PosInfo* pos );
		static void
		DrawRect( const double p0[ 3 ], const double p1[ 3 ], const double p2[ 3 ], const double p3[ 3 ] );
		static void
		DrawTri( const double p0[ 3 ], const double p1[ 3 ], const double p2[ 3 ] );
		static bool
		DrawNormalOnVertex( void );
		static bool
		DrawHandle( void );
		static bool
		DrawAxisInCtlPlaneDegBase( void );
		static bool
		DrawAxisInCtlPlaneDeg( void );
		static bool
		DrawNormalInCtlPlaneDeg( void );
		static bool
		DrawCtlVec( void );
		static void
		DrawLine( const double p0[ 3 ], const double p1[ 3 ] );

		static void
		GetVertexOrg( double vertexPos[ 3 ] );
		static bool
		GetVertexRadial( double vertexPos[ 3 ] );
		static bool
		GetHandleSub( const bool radial, bool* dispChk, double vertexPos[ 3 ], double handleVec[ 3 ] );

		static bool
		GetHandleOrg( bool* dispChk, double handlePos[ 3 ] );
		static bool
		GetHandleRadial( bool* dispChk, double handlePos[ 3 ] );
		static bool
		GetCtlVecOrg( bool* dispChk, double ctlPos[ 3 ] );
		static bool
		GetCtlVecRadial( bool* dispChk, double ctlPos[ 3 ] );
		static bool
		GetCtlVecSub( const bool radial, bool* dispChk, double ctlPos[ 3 ] );
		static bool
		GetWingHandleOrg( bool* dispChk, WingHandleInfo* dt );
		static bool
		GetWingHandleRadial( bool* dispChk, WingHandleInfo* dt );
		static bool
		GetWingHandleSub( const bool radial, bool* dispChk, WingHandleInfo* dt );
		static bool
		GetWingHandleDec( const ulong edgeNo, const short beginEndNo, bool* dispChk, WingHandleInfoSub* dt );
		static bool
		GetWingHandleInc( const ulong edgeNo, const short beginEndNo, bool* dispChk, WingHandleInfoSub* dt );
		static bool
		GetWingHandleExt( const ulong edgeNo, const short beginEndNo, bool* dispChk, double vertexPos[ 3 ],
			double handleVec[ 3 ] );

	private:
		static const double  lenNormalOnVertex;
		static const double  lenNormalInCtlPlane;
		static const double  scaleDownRatio;
};
