/* bvPolygon.h */


class CbvPolygon {
	public:
		enum {
			numLineOnEdge	 = 8
		};
		enum {
			numTriInSurface  = numLineOnEdge * numLineOnEdge,
			numRectInSurface = numLineOnEdge * numLineOnEdge * 2
		};

	public:
		struct VertexRec {
			double  pos[ 3 ];
			double  normal[ 3 ];
		};
		struct PolygonRec {
			VertexRec  vertex[ 3 ];
		};

	public:
		static bool
		Update( void );
		static void
		FreeData( void );

	private:
		static bool
		Alloc( void );
		static bool
		Proc( bool ( *Exec )( const ulong edgeNo, const short beginEndNo, const ulong surfaceNo, bool* dispChk ),
			bool* surfaceErr );
		static bool
		ProcMain( bool ( *Exec )( const ulong edgeNo, const short beginEndNo, const ulong surfaceNo, bool* dispChk ),
			bool* surfaceErr );
		static bool
		ProcVertex( const ulong edgeNo, const short beginEndNo,
			bool ( *Exec )( const ulong edgeNo, const short beginEndNo, const ulong surfaceNo, bool* dispChk ),
			bool* execOp, short* chkSurfExist );
		static bool
		ProcMain( bool ( *Exec )( const ulong surfaceNo ) );
		static bool
		FuncDispChk( const ulong edgeNo, const short beginEndNo, const ulong surfaceNo, bool* dispChk );
		static bool
		AllocData( void );
		static void
		SetPolygon( void );
		static bool
		FuncSetPolygon( const ulong edgeNo, const short beginEndNo, const ulong surfaceNo, bool* dispChk );
		static bool
		FuncSetTri( const CbxCore::PatchRec* patch, const ulong surfaceNo );
		static bool
		FuncSetRect( const CbxCore::PatchRec* patch, const ulong surfaceNo );
		static void
		FuncSetPolygonMain( const VertexRec pnt[ numLineOnEdge+1 ][ numLineOnEdge+1 ], const ulong surfaceNo,
			const short param[ 3 ][ 2 ] );
	
	public:
		static ulong        numPolygonAry;
		static PolygonRec*  polygonAry;
};
